SystemOrganization addCategory: #FixUnderscores!

!MethodReference methodsFor: '*fixUnderscores' stamp: 'bf 12/2/2004 11:16'!
fixUnderscores
	"Replace underscores with :=. Answer true if fixed or no fix necessary, false if manual fix required"

	| src cm |
	"Check if we do need to do anything"
	src := self actualClass sourceCodeAt: methodSymbol.
	(src includes: $_) ifFalse: [^true].

	"Chicken out if there is a literal underscore"
	cm := self actualClass compiledMethodAt: methodSymbol.
	(cm literals anySatisfy: [:lit |
		lit = $_ or: [lit isString and: [lit includes: $_]]]) ifTrue: [^false].

	"Otherwise, replace underscores with :="
	src := src copyReplaceAll: '_' with: ':='.
	self actualClass compile: src.

	^true
! !

Object subclass: #FixUnderscores
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FixUnderscores'!

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 11/26/2004 21:52'!
fixFont: aFont
	| glyph underline |
	glyph := aFont characterFormAt: $_.
	glyph fillWhite.
	underline := aFont ascent + 1.
	glyph fillBlack: (0@underline extent: glyph width@1).
	aFont characterFormAt: $_ put: glyph.! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 11/26/2004 21:52'!
fixFonts
	"self fixFonts"

	StrikeFont allInstances
		do: [:fnt | self fixFont: fnt]
		displayingProgress: 'Fixing Bitmap Fonts'.! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 12/2/2004 11:17'!
fixPackage: aPackageName
	"self fixPackage: 'Game-Physics'"

	| failed |
	failed := OrderedCollection new.
	(PackageInfo named: aPackageName) methods
		do:  [:mRef | mRef fixUnderscores ifFalse: [failed add: mRef]] 
		displayingProgress: 'Fixing ', aPackageName.
	^failed
! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 12/2/2004 11:49'!
fixPackages
	"self fixPackages"

	self fixPackages: #('Game' 'Buccaneer')! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 12/2/2004 11:46'!
fixPackages: packageNames
	"self fixPackages: #('Game' 'Buccaneer')"

	| failed |
	failed := OrderedCollection new.

	packageNames
		do: [:pkgName | failed addAll: (self fixPackage: pkgName)].

	failed isEmpty ifFalse: [
		MessageSet openMessageList: failed
			name: 'These methods with literal underscores were not fixed'
			autoSelect: '_'].! !

!FixUnderscores class methodsFor: 'class initialization' stamp: 'bf 11/26/2004 21:58'!
initialize
	"self initialize"

	self fixFonts.
	self inform: 'Fonts were _fixed_.\You need to run fixPackages yourself.' withCRs.
! !
FixUnderscores initialize!
